=== debian/changelog ===
debmake-doc (1.22-1) unstable; urgency=medium

  * Fix chroot-persistent setup

 -- Osamu Aoki <osamu@debian.org>  Wed, 05 Feb 2025 21:44:21 +0900

debmake-doc (1.21-1) unstable; urgency=medium

  [ Boyuan Yang ]
  * po4a/add_zh-cn/translator.add: Fully use translated strings
  * po4a/add_zh-tw/translator.add: Use my localized name
  * po4a/po/zh-cn.po: Minor updates
  * fix typo: vgry -> very

  [ Otto Kekäläinen ]
  * Improve README structure and clarity
  * Explain the use of git-buildpackage more extensively
  * Proof-read most of the guide and fix spelling and text flow
  * Update examples to have latest directory structure visible in logs
  * Update POT file so translators can work on it
  * Add section about Debputy
  * Satisfy asciidoctor syntax checks

  [ Osamu Aoki ]
  * Fix typo
  * Update upload process
  * update policy to 4.7.0
  * Add reminder for superscript
  * Fix superscript issue.
  * xetex_param.xsl variants
  * nopdf.tex (mod)
  * Makefile: no epub
  * debian/rules (mod)
  * README.md: touch up
  * Makefile: better error message etc.
  * make groom
  * Erase dsc
  * Update example logs
  * spell check for asciidoc source
  * Update spell.dic
  * Update head.txt to db5 style
  * Enable reproducible build
  * Update build-depends list
  * po validation script
  * Add test-* targets
  * Fix po.zh-cn: s/zh-cmn-Hans/zh-cn/
  * Execute "make po" and update ja.po
  * Update PO/POT
  * po: trivial unfuzzy
  * wrap-and-sort: add section
  * Update examples with debmake 4.5.1
  * Fix pt PDF generation bug
  * Update on Portuguese translation
  * pt.po: Fix markup errors and trivials
  * Update po4a/po/README.md

  [ Andrew Kreimer ]
  * Fix typos

 -- Osamu Aoki <osamu@debian.org>  Wed, 05 Feb 2025 14:21:17 +0900
