=== debian/control ===
Source: debmake-doc
Section: doc
Priority: optional
Maintainer: Osamu Aoki <osamu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Indep:
 asciidoctor,
 dblatex,
 docbook-xml,
 docbook-xsl,
 fonts-liberation2,
 fonts-vlgothic,
 fonts-wqy-zenhei,
 latex-cjk-all,
 libxml2-utils,
 locales-all | locales,
 po4a,
 texlive,
 texlive-lang-chinese,
 texlive-lang-cyrillic,
 texlive-lang-english,
 texlive-lang-french,
 texlive-lang-german,
 texlive-lang-japanese,
 texlive-lang-portuguese,
 texlive-xetex,
 w3m,
 xsltproc,
 zip,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://salsa.debian.org/debian/debmake-doc
Vcs-Git: https://salsa.debian.org/debian/debmake-doc.git
Vcs-Browser: https://salsa.debian.org/debian/debmake-doc

Package: debmake-doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 debmake,
Suggests:
 debian-policy,
 developers-reference,
Description: Guide for Debian Maintainers
 This tutorial document describes the building of the Debian
 package to ordinary Debian users and prospective developers using
 the debmake command.
 .
 It is focused on the modern packaging style and comes with many
 simple examples.
  * POSIX shell script packaging
  * Python3 script packaging
  * C with Makefile/Autotools/CMake
  * multiple binary package with shared library etc.
 .
 This package can be considered as the successor to the
 maint-guide package.
