=== debian/tests/control ===
Test-Command: grep -qe 'Guide for Debian Maintainers' /usr/share/doc/debmake-doc/html/index.en.html
Depends:
 @,
