## debmake-doc 1.23

=== debian/changelog ===
debmake-doc (1.23-2) unstable; urgency=medium

  * Stop overwriting debmake-doc-de (Closes: #1124952)

 -- Osamu Aoki <osamu@debian.org>  Fri, 09 Jan 2026 23:14:34 +0900

debmake-doc (1.23-1) unstable; urgency=medium

  * Typo fix: s/gdb/gbp/ (Closes: #1104164)
  * pt.po updated (Closes: #1103583)
  * make po

 -- Osamu Aoki <osamu@debian.org>  Tue, 06 Jan 2026 23:43:39 +0900
