## debmake-doc 1.24

=== examples/Makefile ===
--- 
+++ 
@@ -197,7 +197,7 @@
 
 debhello-%-wrap:
 	cd debhello-$* ; \
-	wrap-and-sort
+	wrap-and-sort -vast
 
 debhello-%/ASCIIDOC_REF:
 	{ cd ../asciidoc ; rg --vimgrep "debhello-$*" *.txt || echo "---" ; } > $@
