=== examples/template/Makefile ===
--- 
+++ 
@@ -50,8 +50,6 @@
 	sed -e '$(FILTER)' > $(BUILD_PATH)/$$i.slog ; \
 	if [ x$$ERR != x0 ]; then exit 1 ; fi ; \
 	done
-	if [ -e $(BUILD_PATH)/step200.slog ]; then \
-		grep -A12  '^I: sanity check of parameters' $(BUILD_PATH)/step200.slog > $(BUILD_PATH)/step200.slog-sanity  ; fi
 	if [ -e $(BUILD_PATH)/step500.slog ]; then \
 		grep -A8  '^ debian/rules binary' $(BUILD_PATH)/step500.slog > $(BUILD_PATH)/step500.slog-binary  ;	fi
 	if [ -e $(BUILD_PATH)/step500.slog ]; then tail -n2 $(BUILD_PATH)/step500.slog >$(BUILD_PATH)/step500.slog-tail  ; fi
