=== debian/changelog ===
debmake-doc (1.24-1) unstable; urgency=medium

  * debmake 5.0.0 adjustment
  * Updated packaging examples using debmake 5.0.0
  * make html to update PO

 -- Osamu Aoki <osamu@debian.org>  Mon, 19 Jan 2026 20:14:37 +0900
