## debmake-doc 1.25

=== examples/Makefile ===
--- 
+++ 
@@ -39,6 +39,7 @@
             lintian\
             locales-all\
             pybuild-plugin-pyproject \
+            python3-setuptools \
             python3-all\
             python3-debian\
             python3-gi\
@@ -52,8 +53,8 @@
 BUILD_DIRS := $(shell find . -maxdepth 1 -type d -regex '\./debhello-.*_build.*' | sed  -e 's,^\./,,')
 UPSTREAM_DIRS := $(filter-out $(BUILD_DIRS),$(ALL_DIRS))
 ASCIIDOC_REF := $(addsuffix /ASCIIDOC_REF, $(BUILD_DIRS))
-TARGZS := $(addsuffix .tar.gz, $(UPSTREAM_DIRS))
-ORIGTARGZS := $(patsubst debhello-%,debhello_%,$(addsuffix .orig.tar.gz, $(UPSTREAM_DIRS)))
+TARZS := $(addsuffix .tar.xz, $(UPSTREAM_DIRS))
+ORIGTARZS := $(patsubst debhello-%,debhello_%,$(addsuffix .orig.tar.xz, $(UPSTREAM_DIRS)))
 BUILDMAKEFILES := $(addsuffix /Makefile, $(BUILD_DIRS))
 BUILDSTAMPS := $(addsuffix -stamp, $(BUILD_DIRS))
 
@@ -67,8 +68,8 @@
 	# === SUCCESS ALL ===
 
 clean:
-	-rm -f $(TARGZS)
-	-rm -f $(ORIGTARGZS)
+	-rm -f $(TARZS)
+	-rm -f $(ORIGTARZS)
 	-rm -f $(BUILDMAKEFILES)
 	-rm -f $(BUILDSTAMPS)
 	# way to clean build results and Makefile link
@@ -82,7 +83,7 @@
 	-rm -rf debhello-*_build*/debmake
 	# post-package snapshot of test
 	-rm -rf debhello-*_build*/package
-	-rm -rf debhello-*_build*/dsc
+	-rm -rf debhello-*_build*/base_dir
 
 distclean: clean
 	-rm -f $(ASCIIDOC_REF)
@@ -100,12 +101,12 @@
 	@ echo "$(BUILD_DIRS)"| xargs -n1
 	# === UPSTREAM_DIRS ===
 	@ echo "$(UPSTREAM_DIRS)" | xargs -n1
-	# === TARGZS ===
-	@ echo "$(TARGZS)" | xargs -n1
-	$(MAKE) $(TARGZS)
-	# === ORIGTARGZS ===
-	@ echo "$(ORIGTARGZS)" | xargs -n1
-	$(MAKE) $(ORIGTARGZS)
+	# === TARZS ===
+	@ echo "$(TARZS)" | xargs -n1
+	$(MAKE) $(TARZS)
+	# === ORIGTARZS ===
+	@ echo "$(ORIGTARZS)" | xargs -n1
+	$(MAKE) $(ORIGTARZS)
 	# === BUILDMAKEFILES ===
 	$(MAKE) $(BUILDMAKEFILES)
 
@@ -117,10 +118,10 @@
 	# === BUILDSTAMPS ===
 	$(MAKE) $(BUILDSTAMPS)
 
-debhello-%.tar.gz: debhello-%/README.md
-	tar --exclude=debhello-$*/debian -cvzf $@ debhello-$*/
-
-debhello_%.orig.tar.gz: debhello-%.tar.gz
+debhello-%.tar.xz: debhello-%/README.md
+	tar --exclude=debhello-$*/debian --xz -cvf $@ debhello-$*/
+
+debhello_%.orig.tar.xz: debhello-%.tar.xz
 	ln -sf $^ $@
 
 debhello-%/Makefile: template/Makefile
