=== examples/template/Makefile ===
--- 
+++ 
@@ -10,27 +10,30 @@
 BUILD_PATH:=$(EXAMPLES_PATH)/$(BUILD)
 # == BUILD_PATH:=$(CURDIR)
 # package build directory (top)
-DSC_PATH:=$(BUILD_PATH)/dsc
-SOURCE_PATH:=$(DSC_PATH)/$(PROJECT)
+BASE_DIR:=base_dir
+BASE_PATH:=$(BUILD_PATH)/$(BASE_DIR)
+BASE_DIR:=$(shell echo $(PROJECT)|sed -e 's#/*$$##' )
+SOURCE_PATH:=$(BASE_PATH)/$(PROJECT)
+SOURCE_DIR:=$(shell echo $(PROJECT)|sed -e 's#/*$$##' )
 PATH := $(EXAMPLES_PATH)/bin:$(PATH)
 REFBUILD1:=debhello-0.0_build-1
 REFBUILD2:=debhello-0.0_build-2
 REFBUILDP:=debhello-1.1_build-1
-PROJECTDIR:=$(DSC_PATH)/$(PROJECT)
+PROJECTDIR:=$(BASE_PATH)/$(PROJECT)
 TERM:=xterm
 TREE_COLORS:=
 LS_COLORS:=
 CDPATH:=
 NOANSI:=s/\x1B\[([0-9]{1,2}(;[0-9]{1,2})?)?[m|K]//g
 FILTER :=s/\(^.............................................................................\).*$$/\1.../
-TGZ:=tar.gz
-export BUILD_PATH DSC_PATH EXAMPLES_PATH SOURCE_PATH PATH PROJECT PROJECTDIR TREE_COLORS LS_COLORS TERM CDPATH TGZ
+TARZ:=tar.xz
+export BUILD_PATH BASE_PATH BASE_DIR EXAMPLES_PATH SOURCE_PATH SOURCE_DIR PATH PROJECT PROJECTDIR TREE_COLORS LS_COLORS TERM CDPATH TARZ
 
 stepcmds := $(sort $(wildcard *.cmd))
 steps := $(patsubst %.cmd, %, $(stepcmds))
 
 all:
-	mkdir -p $(DSC_PATH)
+	mkdir -p $(BASE_PATH)
 	echo $(BUILD_PATH) > $(BUILD_PATH)/next.dir
 	echo $(BUILD) > $(BUILD_PATH)/build
 	echo $(PROJECT) > $(BUILD_PATH)/project
@@ -46,7 +49,7 @@
 	grep -v -e '^Script started on' | \
 	grep -v -e '^Script done on' | \
 	sed -r '$(NOANSI)' | \
-	sed -e 's#$(DSC_PATH)#/path/to#g' | \
+	sed -e 's#$(BUILD_PATH)#/path/to#g' | \
 	sed -e '$(FILTER)' > $(BUILD_PATH)/$$i.slog ; \
 	if [ x$$ERR != x0 ]; then exit 1 ; fi ; \
 	done
@@ -55,7 +58,7 @@
 	if [ -e $(BUILD_PATH)/step500.slog ]; then tail -n2 $(BUILD_PATH)/step500.slog >$(BUILD_PATH)/step500.slog-tail  ; fi
 
 clean:
-	-rm -rf $(DSC_PATH)
+	-rm -rf $(BASE_PATH)
 	-rm -rf debmake
 	-rm -rf package
 	-rm -f build
@@ -82,7 +85,7 @@
 check:
 	@echo "EXAMPLES_PATH  = $(EXAMPLES_PATH)  all examples including tar.gz"
 	@echo "BUILD_PATH     = $(BUILD_PATH) each build cases"
-	@echo "DSC_PATH       = $(DSC_PATH) where *.deb and *.dsc are generated"
+	@echo "BASE_PATH       = $(BASE_PATH) where *.deb and *.dsc are generated"
 	@echo "SOURCE_PATH    = $(SOURCE_PATH) where extracted tar ball source tree"
 	@echo "PROJECT        = $(PROJECT) upstream project name"
 	@echo "BUILD          = $(BUILD) build case naem"
