=== debian/changelog ===
debmake-doc (1.25-1) unstable; urgency=medium

  * debian/copyright (mod)
  * Update for debmake 5.1.0
  * examples/* (mod)
  * make po

 -- Osamu Aoki <osamu@debian.org>  Fri, 30 Jan 2026 13:48:22 +0000
