## debmake-doc 1.26

=== examples/debhello-3.4/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.31)
project(debhello)
set(PACKAGE_AUTHOR "Osamu Aoki")
add_subdirectory(po)
add_subdirectory(lib)
add_subdirectory(src)
add_subdirectory(man)
add_subdirectory(data)
