=== debian/changelog ===
debmake-doc (1.26-1) unstable; urgency=medium

  * asciidoc/* updates for dgit
  * update examples with debmake 5.1.2

 -- Osamu Aoki <osamu@debian.org>  Tue, 03 Feb 2026 21:07:13 +0900
