## debmake-doc 1.27

=== examples/Makefile ===
--- 
+++ 
@@ -1,15 +1,10 @@
 # Build all Debian packaging examples
-# Copyright (C) 2021 Osamu Aoki
-
-# Standards-Version: 4.6.2
-# Homepage: <insert the upstream URL, if relevant>
-# Homepage: https://salsa.debian.org/debian/debmake-doc
-# Vcs-Git: https://salsa.debian.org/debian/debmake-doc.git
-# Vcs-Browser: https://salsa.debian.org/debian/debmake-doc
-
-# Set the following before "make groom"
+# Copyright (C) 2026 Osamu Aoki
+
+# Set the following before "make groom" to update common setting
+# for debian/control
 HOMEPAGE = https://salsa.debian.org/debian/debmake-doc
-STDVER = 4.6.2
+STDVER = 4.7.3
 DHCOMPAT = 13
 MAINTNM = Osamu Aoki <osamu@debian.org>
