=== debian/changelog ===
debmake-doc (1.27-1) unstable; urgency=medium

  * Correct sbuild and gbp option examples
  * Drop piuparts in Tool usages
  * Mention "cme fix dpkg"
  * Mention schroot vs. unsare for piuparts
  * Use tar with --xz option across document
  * update manpage for debmake 5.1.3
  * pt.po update and "make po"

 -- Osamu Aoki <osamu@debian.org>  Sun, 08 Feb 2026 14:50:35 +0900
