## debmake-doc 1.28

=== debian/changelog ===
debmake-doc (1.28-1) unstable; urgency=medium

  [ Osamu Aoki ]
  * FHS 3.0
  * Fix typo to make cme as a section
  * apply "cme fix dpkg" to examples
  * Add openPGP setup
  * make po (mod)
  * debmake 5.1.4 examples

  [ Boyuan Yang ]
  * po4a/po/zh-cn.po: Refresh and add some translation

  [ Dorle Osterode ]
  * Use openPGP instead of GPG where appropriate

 -- Osamu Aoki <osamu@debian.org>  Wed, 11 Feb 2026 10:10:41 +0000
